// xls->csv convertion script
// author: Masashi N.

main();
function main()
{
	var Version = "2.00";

	function VersionInfo()
	{
		return String(
			"xls->csv convertion script  version " + Version + "\n" +
			"\n" +
			"Running WSH: version " + WScript.Version + " build " + WScript.BuildVersion + "\n" +
			"");
	}
		
	function Usage()
	{
		return String(
			"g : xls2csv.js [IvV...] <xlst@C>" + "\n" +
			"\n" +
			"IvV :" + "\n" +
			" /Browse     o͐tH_I_CAO\" + "\n" +
			" /NoLog      Ot@Co͂Ȃ" + "\n" +
			" /NoConfirm  mF_CAO\Ȃ" + "\n" +
			" /NoReport   ϊ|[g\Ȃ" + "\n" +
			" /Help       ̃wv\" + "\n" +
			" /Version    ϊXNvg̃o[W\" + "\n" +
			"");
	}

	var LogFile = null;	// TextStream object of log file should be assigned.
	var WSShell = null;	// WScript shell object
	var ConfirmTitle = WScript.Name;	// title of confirm dialog
	var ConfirmSubtitle = "";	// subtitle of confirm dialog
	var Args = WScript.Arguments;

	// check arguments and environment
	if (Args.Named.Exists("V") || Args.Named.Exists("Version")) Quit(0x0, VersionInfo());
	if (Args.Named.Exists("?") || Args.Named.Exists("Help")|| Args.Named.Exists("H")) Quit(0x0, Usage());

	var fDebug = Args.Named.Exists("Debug");
	var fCScript = WScript.FullName.substring(WScript.FullName.length - 11).toLowerCase() == "cscript.exe";
	CheckError(fCScript && (!WScript.StdOut || !WScript.StdIn), 0x101, "CScript ŎsĂ܂ StdIn, StdOut pł܂.");

	if (Args.Named.Exists("Setup") || Args.Named.Exists("Install")) return Setup(true);
	if (Args.Named.Exists("Unsetup") || Args.Named.Exists("Uninstall")) return Setup(false);

	if (Args.Count() == 0) {	// to setup wizard
		var msg;
		if (fCScript) {
			msg = "CSVϊc[ ZbgAbv vO" + "\n\n" +
				"ReLXgj[ւ̒ǉsꍇ Y ͂Ă." + "\n" +
				"ReLXgj[̍폜sꍇ N ͂Ă." + "\n" +
				"߂ꍇ C ͂Ă." + "\n";
		} else {
			ConfirmTitle = "CSVϊc[ ZbgAbv vO";
			ConfirmSubtitle = "";
			msg =
				"ReLXgj[ւ̒ǉsꍇ [ ͂ ] NbNĂ." + "\n" +
				"ReLXgj[̍폜sꍇ [  ] NbNĂ." + "\n" +
				"߂ꍇ [ LZ ] NbNĂ." + "\n";
		}
		var RetVal = ConfirmYesNoCancel(msg, 2);
		if (RetVal < 0) return;
		return Setup(RetVal > 0);
	}

	// convertion options
	var fFolderBrowse = Args.Named.Exists("Browse");
	var fLogged = !Args.Named.Exists("NoLog");
	var fConfirmMsg = !Args.Named.Exists("NoConfirm");
	var fReportMsg = !Args.Named.Exists("NoReport");
	// force to change
	if (fCScript) {
		fFolderBrowse = false;
	}
	if (!WScript.Interactive) {
		fFolderBrowse = false;
		fConfirmMsg = false;
		if (!fCScript) {
			fReportMsg = false;
		}
	}
	if (fDebug) {
		fLogged = true;
		if (WScript.Interactive || fCScript) {
			fReportMsg = true;
		}
	}

	// create file system object
	var FileSys = WScript.CreateObject("Scripting.FileSystemObject");
	CheckError(!FileSys, 0x201, "t@CVXeIuWFNg쐬ł܂ł.");

	// get .xls file path
	var XlsFilePath = (Args.Unnamed.Count > 0)? Args.Unnamed.Item(0): null;
	CheckError(!XlsFilePath || XlsFilePath == "", 0x120, "t@Cw肳Ă܂.");
	CheckError(!FileSys.FileExists(XlsFilePath), 0x121, "t@C \"" + XlsFilePath + "\" ݂͑܂.");

	// confirm to convert
	if (fConfirmMsg) {
		var msg = "t@C \"" + XlsFilePath + "\" CSVt@C֕ϊ܂.";
		if (ConfirmYesNo(msg, 0) <= 0) Quit(0x1);
	}

	var StartTime = new Date();

	// create Excel application object
	var Excel = WScript.CreateObject("Excel.Application");
	CheckError(!Excel, 0x220, "ExcelAvP[VIuWFNg쐬ł܂ł.", "Microsoft Excel ɃCXg[Ă邩mFĂ.");
	Excel.Visible = false;
	
	// get/create csv folder
	var CsvDirPath;
	if (fFolderBrowse) {
		var Shell = WScript.CreateObject("Shell.Application");
		CheckError(!Shell, 0x210, "VFAvP[VIuWFNg쐬ł܂ł.");

		var ShellFolder = Shell.BrowseForFolder(0, "CSVt@Co͂tH_IĂ.", 0x0040);
		CheckError(!ShellFolder, 0x211, "tH_I܂ł.");

		CsvDirPath = ShellFolder.Items().Item().Path;
	} else {	// folder auto creation
		CsvDirPath = XlsFilePath + "2csv";
		CheckError(FileSys.FolderExists(CsvDirPath), 0x140, "tH_ \"" + CsvDirPath + "\" łɑ݂܂.");

		try {
			FileSys.CreateFolder(CsvDirPath);
		} catch (e) {
			CheckError(e, 0x141, "tH_ \"" + CsvDirPath + "\" ̍쐬Ɏs܂.");
		}
	}
	CsvDirPath += "\\";
	CheckError(!FileSys.FolderExists(CsvDirPath), 0x14F, "tH_ \"" + CsvDirPath + "\" ݂܂.");

	// open log file
	if (fLogged) {
		var LogFilePath = CsvDirPath + "xls2csv.log";
		CheckError(FileSys.FolderExists(LogFilePath), 0x160, "Ot@C \"" + LogFilePath + "\" łɑ݂܂.");

		try {
			LogFile = FileSys.CreateTextFile(LogFilePath);
		} catch(e) {
			CheckError(e, 0x161, "Ot@C \"" + LogFilePath + "\" ̍쐬Ɏs܂.");
		}
	}

	// open xls file
	try {
		Excel.WorkBooks.Open(XlsFilePath);
	} catch(e) {
		CheckError(e, 0x301, "t@C \"" + XlsFilePath + "\" ̃I[vɎs܂.");
	}

	if (LogFile) {
		LogFile.WriteLine("\"" + XlsFilePath + "\" ϊ܂...");
	}

	CheckError(Excel.WorkBooks.Count <= 0, 0x302, "Excel ubN t@C \"" + XlsFilePath + "\" ɂ̓ubN݂܂.");
	CheckWarning(Excel.WorkBooks.Count > 1, 0x303, "Excel ubN t@C \"" + XlsFilePath + "\" ɂ͕̃ubN݂܂.", "ŏ̃ubNϊ܂.");

	// get workbook object
	var ExcelBook = Excel.WorkBooks.Item(1);
	CheckError(!ExcelBook, 0x305, "Excel ubN t@C \"" + XlsFilePath + "\" ̃ubNJ܂ł.");

	if (LogFile) {
		LogFile.WriteLine("");
	}

	var ErrorSheetCount = 0;
	var SheetsMaxCount = ExcelBook.WorkSheets.Count;
	for (var i = 1; i <= SheetsMaxCount; ++i) {
		// get worksheet object
		var Sheet = ExcelBook.WorkSheets.Item(i);
		if (!Sheet) {
			if (LogFile) LogFile.WriteLine("Sheet[" + i + "]\t->\tNG");
			++ErrorSheetCount;
			continue;
		}
		
		// check file presence
		var CsvFilePath = CsvDirPath + Sheet.Name + ".csv";
		if (FileSys.FileExists(CsvFilePath)) {
			if (LogFile) LogFile.WriteLine("Sheet[" + i + "] " + Sheet.Name + "\t->\tNG\tt@C \"" + CsvDirPath + "\" łɑ݂܂.");
			++ErrorSheetCount;
			continue;
		}

		// output with convert
		try {
			Sheet.SaveAs(CsvFilePath, 6);	// xlCSV == 6
			if (LogFile) LogFile.WriteLine("Sheet[" + i + "] " + Sheet.Name + "\t->\t" + CsvFilePath);
		} catch (e) {
			if (LogFile) LogFile.WriteLine("Sheet[" + i + "] " + Sheet.Name + "\t->\tNG");
			++ErrorSheetCount;
		}
	}

	// close book
	Excel.Application.DisplayAlerts = false;
	ExcelBook.Close();
	ExcelBook = null;
	Excel.Application.DisplayAlerts = true;

	Excel.Application.Quit();
	Excel = null;

	var EndTime = new Date();

	// report
	var ReportError = (ErrorSheetCount == 0)? "G[V[g͂܂.": "ϊ" + ErrorSheetCount + "̃V[gŃG[܂.";
	var ReportTime = "v: " + ((EndTime - StartTime) / 1000) + " b";
	
	if (LogFile) {
		LogFile.WriteLine("");
		LogFile.WriteLine(ReportError);
		LogFile.WriteLine(ReportTime);

		// close log file
		LogFile.Close();
		LogFile = null;
	}

	// report
	if (fReportMsg) {
		WScript.Echo("ϊI܂.\n" + ReportError + "\n" + ReportTime +"\n");
	}

	return;
	
	//////////////////////////////////////////////////////

	function Quit(qcode, msg)
	{
		if (msg) {
			for (var i = 2; i < arguments.length; ++i)
				msg += "\n" + arguments[i];
			WScript.Echo(msg);
		}
		WScript.Quit(qcode);
	}

	function EchoForBatchMode(msg)
	{
		if (fCScript) {
			WScript.StdOut.WriteLine(msg);
		} else {
			GetWSShell().Popup(msg);
		}
	}
	
	function GetWSShell()
	{
		if (!WSShell) {
			WSShell = WScript.CreateObject("WScript.Shell");
			CheckError(!WSShell, 0x205, "WScriptVFIuWFNg쐬ł܂ł.");
		}
		return WSShell;
	}

	//////////////////////////////////////////////////////
	// error and warning
	//
	// successful quit code is from 0 to 0xFF.
	// faital error code is from 0x0100 to 0x0FFF.
	// warning code is from 0x1100 to 0x1FFF.
	
	// 0  normally quit. including VersionInfo and Usage
	// 1  quit by cancel.
	// 0x100-0x1FF arguments and environment error
	//   0x100-0x10F  environment flags and variables
	//   0x110-0x11F  setup environment
	//   0x120-0x12F  input file
	//   0x140-0x14F  input folder
	//   0x160-0x16F  log file
	// 0x200-0x2FF object creation error
	//   0x200-0x20F  basic objects (WScript.Shell, FileSystemObject, etc)
	//   0x210-0x21F  Shell.App objects
	//   0x220-0x22F  Excel.App objects
	// 0x300-0x3FF  Excel operation
	//   0x300-0x30F  book operation
	// 0x400-0x4FF  setup operation
	//   0x400-0x40F  registry operation in setup
	//   0x410-0x41F  registry operation in unsetup

	function CheckError(iferror, code, msg)
	{
		if (iferror) {
			msg = "ERROR " + code +" : " + msg;
			for (var i = 3; i < arguments.length; ++i)
				msg += "\n" + arguments[i];
			Quit(code, msg);
		}
	}

	function CheckWarning(ifwarn, code, msg)
	{
		if (ifwarn) {
			msg = "Warning " + code +" : " + msg;
			if (LogFile) {
				LogFile.WriteLine(msg);
				for (var i = 3; i < arguments.length; ++i)
					LogFile.WriteLine(arguments[i]);
			}
			for (var i = 3; i < arguments.length; ++i)
				msg += "\n" + arguments[i];
			WScript.Echo(msg);
		}
	}

	//////////////////////////////////////////////////////
	// confirmation

	function ConfirmYesNo(msg, defbtn)
	{
		if (fCScript) {
			WScript.StdOut.WriteLine(msg);
			WScript.StdOut.Write("Yes/No ? ");
			var answer = WScript.StdIn.ReadLine();
			answer = answer.charAt(0).toUpperCase();
			if (answer == "Y") return 1;
		} else {
			var ret = GetWSShell().Popup(msg, 0, ConfirmTitle+ConfirmSubtitle, 0x24 | (defbtn * 0x100));
			if (ret == 0x06) return 1;
		}
		return 0;
	}
	
	function ConfirmYesNoCancel(msg, defbtn)
	{
		if (fCScript) {
			WScript.StdOut.WriteLine(msg);
			WScript.StdOut.Write("Yes/No/Cancel ? ");
			var answer = WScript.StdIn.ReadLine();
			answer = answer.charAt(0).toUpperCase();
			if (answer == "Y") return 1;
			if (answer == "N") return 0;
		} else {
			var ret = GetWSShell().Popup(msg, 0, ConfirmTitle+ConfirmSubtitle, 0x23 | (defbtn * 0x100));
			if (ret == 0x06) return 1;
			if (ret == 0x07) return 0;
		}
		return -1;
	}

	function ConfirmOkCancel(msg, defbtn)
	{
		if (fCScript) {
			WScript.StdOut.WriteLine(msg);
			WScript.StdOut.Write("Ok/Cancel ? ");
			var answer = WScript.StdIn.ReadLine();
			answer = answer.charAt(0).toUpperCase();
			if (answer == "O") return 1;
		} else {
			var ret = GetWSShell().Popup(msg, 0, ConfirmTitle+ConfirmSubtitle, 0x21 | (defbtn * 0x100));
			if (ret == 0x01) return 1;
		}
		return -1;
	}

	//////////////////////////////////////////////////////
	// setup

	function Setup(isRegistering)
	{
		var MenuItemText = "CSVt@Cɕϊ(&C)";
		var ConvMenuRegKey = "xls2csv";
		ConfirmTitle = ConvMenuRegKey + " j[̃ZbgAbv";

		// check mode
		if (!WScript.Interactive) {
			EchoForBatchMode("ob`[hł̓ZbgAbvł܂.");
			WScript.Quit(0x110);
		}

		if (isRegistering) {
			Register();
		} else {
			Unregister();
		}

		return;

		//////////////////////////////////////////////////////
		// register

		function Register()
		{
			// get file type associated with .xls
			var XlsFileType;
			try {
				XlsFileType = GetWSShell().RegRead("HKCR\\.xls\\");
			} catch (e) {
				CheckError(e, 0x401, "WXgL[ HKCR\\.xls\\ ǂݎ܂.",
						"Microsoft Excel ɃCXg[Ă邩mFĂ.");
			}
			CheckError(XlsFileType.indexOf("Excel.Sheet") < 0, 0x402,
					"gq .xls ExcelubNȊÕt@C^CvɊ֘AtĂ悤ł.",
					"ϊj[Zbgł܂.");

			// get registry key
			var XlsTypeTitle;
			try {
				XlsTypeTitle = GetWSShell().RegRead("HKCR\\" + XlsFileType + "\\");
			} catch (e) {
				CheckError(true, 0x405, "WXgL[ HKCR\\" + XlsFileType + "\\ ܂.");
			}
			CheckError(XlsTypeTitle.indexOf("Excel") < 0, 0x406,
					"gq .xls ̓t@C^Cv \"" + XlsTypeTitle + "\" Ɋ֘AtĂ悤ł.",
					"ϊj[Zbgł܂.");

			var RegPath = "HKCR\\" + XlsFileType + "\\shell\\" + ConvMenuRegKey + "\\";
			try {
				if (GetWSShell().RegRead(RegPath)) {
					CheckError(true, 0x408, ".xls ̃ReLXgj[ɂCSVϊR}hłɒǉĂ悤ł.");
				}
			} catch (e) {
				if (fDebug) WScript.Echo("WXgL[ " + RegPath + " ͓ǂݎ܂ł.");
			}

			// command string
			var ExecCmdString = "WScript.exe \"" + WScript.ScriptFullName + "\"";

			// select options
			var RetVal;
			ConfirmSubtitle = " - Step 1 / 5";
			RetVal = ConfirmYesNoCancel(
					XlsTypeTitle + " ̃ReLXgj[CSVϊR}hǉ܂." + "\n\n" +
					"Step 1 / 5" + "\n" + "sɏo͐tH_I܂ ?", 1);
			if (RetVal < 0) Quit(0x1);
			var fBrowse = (RetVal > 0);

			var fConfirm = false;
			if (!fBrowse) {
				ConfirmSubtitle = " - Step 2 / 5";
				RetVal = ConfirmYesNoCancel("Step 2 / 5" + "\n" + "sɊmF_CAO\܂ ?", 1);
				if (RetVal < 0) Quit(0x1);
				fConfirm = (RetVal > 0);
			}

			ConfirmSubtitle = " - Step 3 / 5";
			RetVal = ConfirmYesNoCancel("Step 3 / 5" + "\n" + "Ot@Co͂܂ ?", 0);
			if (RetVal < 0) Quit(0x1);
			var fLogged = (RetVal > 0);

			ConfirmSubtitle = " - Step 4 / 5";
			RetVal = ConfirmYesNoCancel("Step 4 / 5" + "\n" + "ϊ|[g\܂ ?", 1);
			if (RetVal < 0) Quit(0x1);
			var fReport = (RetVal > 0);

			var OptionList = "";
			OptionList += "  tH_I:   " + (fBrowse?  ""    : "Ȃ"    );
			if (!fBrowse || fDebug) {
				OptionList += "\n";
				OptionList += "  mF_CAO: " + (fConfirm? "\": "\Ȃ");
			}
			OptionList += "\n";
			OptionList += "  Ot@C:   " + (fLogged?  "o͂": "o͂Ȃ");
			OptionList += "\n";
			OptionList += "  ϊ|[g:   " + (fReport?  "\": "\Ȃ");

			ConfirmSubtitle = " - Step 5 / 5";
			RetVal = ConfirmOkCancel("Step 5 / 5" + "\n" + "ȉ̃IvVŃZbgAbv܂." + "\n" + OptionList, 0);
			if (RetVal <= 0) Quit(0x1);

			if (fBrowse)   ExecCmdString += " /Browse";
			if (!fConfirm) ExecCmdString += " /NoConfirm";
			if (!fLogged)  ExecCmdString += " /NoLog";
			if (!fReport)  ExecCmdString += " /NoReport";
			ExecCmdString += " \"%1\"";

			if (fDebug) {
				WScript.Echo("ZbgAbve" +
					"\nj[: " + MenuItemText +
					"\nsR}h: " + ExecCmdString );
			}

			// setup registry
			try {
				GetWSShell().RegWrite(RegPath, MenuItemText);
				GetWSShell().RegWrite(RegPath + "command\\", ExecCmdString);
			} catch (e) {
				CheckError(e, 0x40A, "WXgւ݂̏Ɏs܂.");
			}

			WScript.Echo("ZbgAbv͐Ɋ܂.");
		}

		//////////////////////////////////////////////////////
		// unregister

		function Unregister()
		{
			// get file type associated with .xls
			var XlsFileType;
			try {
				XlsFileType = GetWSShell().RegRead("HKCR\\.xls\\");
			} catch (e) {
				CheckError(e, 0x411,"WXgL[ HKCR\\.xls\\ ǂݎ܂ł.",
					"ϊj[̓ZbgĂȂ\܂.");
			}

			// reg key path
			var RegPath = "HKCR\\" + XlsFileType + "\\shell\\" + ConvMenuRegKey + "\\";

			// check reg key
			try {
				GetWSShell().RegRead(RegPath);
			} catch (e) {
				CheckError(e, 0x412, "WXgL[ " + RegPath + " ǂݎ܂ł.",
					"ϊj[̓ZbgĂȂ\܂.");
			}

			// confirm
			ConfirmSubtitle = "";
			var RetVal = ConfirmOkCancel(".xls ̃ReLXgj[CSVϊR}h폜܂.", 1);
			if (RetVal <= 0) Quit(0x1);

			// delete reg key
			try {
				GetWSShell().RegDelete(RegPath + "command\\");
				GetWSShell().RegDelete(RegPath);
			} catch (e) {
				CheckError(e, 0x41A, "WXgL[̍폜Ɏs܂.", RegPath);
			}

			WScript.Echo("폜͐Ɋ܂.");
		}

	}	// end of Setup()

}	// end of main()
